# $Project: polymake $$Id: polymake.spec 9877 2010-11-08 18:58:46Z gawrilow $

Summary: Algorithms around polytopes and polyhedra
Name: polymake
Version: 2.9.9
Release: 1
License: GPL
Group: Applications/Sciences/Mathematics
URL: http://www.polymake.de/
Vendor: TU Darmstadt, Algorithmic Discrete Mathematics
Packager: Ewgenij Gawrilow
Icon: as3.gif

%define topname %{name}-%{version}
Source: http://wwwopt.mathematik.tu-darmstadt.de/polymake/lib/exe/fetch.php/download/%{topname}.tar.bz2
Requires: gcc-c++
Requires: gmp gmp-devel
Requires: java >= 1.5
Requires: perl >= 5.8.1
Requires: perl(XML::LibXML) perl(XML::SAX::Base) perl(XML::Writer) perl(XML::LibXSLT)
Requires: perl(Term::ReadLine::Gnu)
BuildRequires: gcc-c++
BuildRequires: gmp gmp-devel
BuildRequires: java-devel >= 1.5
BuildRequires: perl >= 5.8.1
BuildRequires: xhtml-dtd
BuildRequires: perl(XML::LibXML) perl(XML::SAX::Base) perl(XML::Writer) perl(ExtUtils::MakeMaker)

Prefix: /usr

%description
Polymake is a versatile tool for the algorithmic treatment of
polytopes and polyhedra.  It offers an unified interface to a wide
variety of algorithms and free software packages from the computational
geometry field, such as convex hull computation or visualization tools.

The 2.9 series are test versions towards the "next generation" polymake.
They introduce an interactive shell, the XML-base file format, more
efficient C++/perl interface, and many other new features.

%files
%attr(-, bin, bin) /usr/bin/polymake
%attr(-, bin, bin) /usr/share/polymake
%attr(-, bin, bin) %dir /usr/%{_lib}/polymake
%attr(-, bin, bin) %dir /usr/%{_lib}/polymake/perlx
%attr(-, bin, bin) /usr/%{_lib}/polymake/lib
%attr(-, bin, bin) %config /usr/%{_lib}/polymake/conf.make
%attr(-, bin, bin) %doc /usr/share/doc/packages/polymake

%define guess_prefix : ${RPM_INSTALL_PREFIX:=%{_prefix}} ${RPM_INSTALL_PREFIX:=$RPM_INSTALL_PREFIX0} ${RPM_INSTALL_PREFIX:=/usr}

# RPM still does not understand line continuations in spec files!

%define build_perlx echo "Building perl extensions for polymake...";  : ${TMPDIR:=%{_tmppath}} ${TMPDIR:=/var/tmp};  rm -rf $TMPDIR/%{topname}-perlx;  mkdir $TMPDIR/%{topname}-perlx;  pushd $TMPDIR/%{topname}-perlx;  TOP=$RPM_INSTALL_PREFIX/share/polymake /usr/bin/perl $RPM_INSTALL_PREFIX/share/polymake/perl/ext/Makefile.PL;  make all pure_install InstallDir=$RPM_INSTALL_PREFIX/%{_lib}/polymake;  popd;  rm -rf $TMPDIR/%{topname}-perlx

%post
%{guess_prefix}
%{build_perlx}

if [ "$RPM_INSTALL_PREFIX" != /usr ]; then
   /usr/bin/perl -i -p -e 's|(PREFIX=).*|$1'$RPM_INSTALL_PREFIX'|' $RPM_INSTALL_PREFIX/%{_lib}/polymake/conf.make
fi


%triggerin -- perl
%{guess_prefix}

eval perl_`/usr/bin/perl -V:version`
if [ ! -d $RPM_INSTALL_PREFIX/%{_lib}/polymake/perlx/${perl_version} ]; then
  %{build_perlx}
fi


%preun
%{guess_prefix}

if [ $1 = 0 ]; then
   rm -rf $RPM_INSTALL_PREFIX/%{_lib}/polymake/perlx/*
fi


%prep
%setup -q -n %{topname}

%define ProjectTop %{_builddir}/%{topname}

%build

if [ "%{_host_cpu}" = x86_64 -a "%{_target_cpu}" != x86_64 ]; then
  LDflags="LDFLAGS=-m32"
fi

./configure --prefix=/usr --libdir=/usr/%{_lib}/polymake --docdir=/usr/share/doc/packages/%{name} \
            --build=%{_target_cpu} --without-prereq \
	    CFLAGS="$(perl -e '$_=q{'"$RPM_OPT_FLAGS"'}; s/(?:^|\s)-(?:g|O\d)(?=\s|$)//g; print;')" $LDFLAGS

make Arch=%{_target_cpu} %{?_smp_mflags}%{?!_smp_mflags:%(NCPUS=`grep -c '^processor' /proc/cpuinfo`; [ -n "$NCPUS" -a "$NCPUS" -gt 1 ] && echo -j$NCPUS )} ProcessDep=n


%install
make Arch=%{_target_cpu} PREFIX=/usr ${RPM_BUILD_ROOT:+DESTDIR=$RPM_BUILD_ROOT} install docs
perl support/install.pl -m 755 perl/ext $RPM_BUILD_ROOT/usr/share/polymake/perl/ext
mkdir $RPM_BUILD_ROOT/usr/%{_lib}/polymake/perlx

%define __find_provides %{ProjectTop}/support/find-provides
%define __find_requires %{ProjectTop}/support/find-requires
